/*
	padpage.c
	tab=8
*/

#define PROGRAM   "pbhΉy[W["
#define VERSION   "V0.06"
#define FIRSTDATE "94/11/15"
#define FINALDATE "95/02/20"
#define USAGE     "   for FM-snvmr R\[[h\n" \
		  "Usage : padpage [-t[1-9]] [-s[wait]] [-5] filename"
#define MAIN

#include "calo.h"
#include "padpage.h"
#include <fcntl.h>


void main( int argc, char *argv[] ){		/* C */

	int i;
	char *name;

	/* IvVXCb`Zbg */
	if( argc == 1 ) usage( argv[0] );
	for( i = 1 ; i < argc ; i++ ){
		if( argv[i][0] == '-' || argv[i][0] == '/')
		switch ( argv[i][1] ) {
		case 'T':
		case 't':
			tabs = atoi(argv[i]+2);
			tabs = ( tabs < 1 || tabs > 9 ) ? 9 : tabs;
			break;
		case 'S':
		case 's':
			sclw = ( sclw = atoi(argv[i]+2)) > 99 ? 99 : sclw ;
			break;
		case '5':
			lines = 5;
			maxdisp = 21;
			break;
		case 'H':
		case 'h':
		case '?':
			usage(argv[0]);
		default:
			usage("ȃXCb`ł.");
			break;
		}
		else name = argv[i];
	}
	/* t@CI[v */
	if( ( fp = open( name, O_RDONLY ) ) < 0 ){
		usage( argv[0] );
	}
	/* pbh */
	padinit();
	/* J[\ */
	cur( OFF );
	/* ʃ[h */
	if( lines == 0 )
		width( 20 );
	/* C */
	{
		int rr = OFF;
		int j = 1;
		int l,ll=0;
		static const char *usfn = {
			"\f"ESC_GRr " t@C: %-s " ESC_reset
			};

		/* filename disp */
		cprintf( usfn , name );
		/* auto scroll */
		sclw = 0;
		if( sclw > 0 )
			mline = ppgscroll('+',j);
		/* Iy[V */
		while( rr == OFF ){
			dsppage( j,l = setline( j ) );
			if( inkey() == NULL )
			ll = setline( ( ll < l ) ? l : ll );
			switch ( inkey() ) {
			case RIGHT:
				j += maxdisp/2;
				break;
			case LEFT:
				j = 1;
				break;
			case UP:
				j--;
				break;
			case DOWN:
				j++;
				break;
			case ESCKEY: /* sellect */
				rr = ON;
				break;
			case ' ':
			case QUIT: /* B botan */
				j -= maxdisp/2;
				break;
			case '\r':
			case EXEC: /* A botan */
				rr = ppgmenu( &j ); /* menu */
				cprintf( usfn, name );
				j = dsppage( j, -1 );	/* ĕ\ */
			default:
				break;
			}
			if( j < 1 ) j = 1;
			/*
			*/
			if( mp_eof && j > ll ) j = ll ;
		}
	}
	close( fp );
	/* J[\ */
	cur( ON );
	width( 25 );
}
